unit uGameField;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TfGameField = class(TForm)
    Panel1: TPanel;
    l1: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    l2: TLabel;
    l3: TLabel;
    l4: TLabel;
    ld1: TLabel;
    ld2: TLabel;
    ld3: TLabel;
    ld4: TLabel;
    ld5: TLabel;
    ld6: TLabel;
    ld7: TLabel;
    ld8: TLabel;
    ld9: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    mMes: TMemo;
    Panel5: TPanel;
    Panel6: TPanel;
    lt5: TLabel;
    Panel7: TPanel;
    lt6: TLabel;
    Panel8: TPanel;
    lt7: TLabel;
    Panel9: TPanel;
    lt8: TLabel;
    bTest: TButton;
    bNew: TButton;
    lt4: TLabel;
    sb1: TSpeedButton;
    sb2: TSpeedButton;
    sb3: TSpeedButton;
    sb4: TSpeedButton;
    Panel10: TPanel;
    lt3: TLabel;
    Panel11: TPanel;
    lt2: TLabel;
    Panel12: TPanel;
    lt1: TLabel;
    Panel13: TPanel;
    lt9: TLabel;
    Panel14: TPanel;
    lt10: TLabel;
    Panel15: TPanel;
    lt11: TLabel;
    cbAutoSelect: TCheckBox;
    cbAutoStart: TCheckBox;
    mHS: TMemo;
    procedure l4DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure l1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ld1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure l1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bNewClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bTestClick(Sender: TObject);
    procedure cbAutoSelectClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  THiScore=record
  	Name: string[12];
    Score: byte;
  end;

const
  hsf='HiScores.dat';

var
  fGameField: TfGameField;
  Num: string[4];
  Tries: integer;
  hs: file of THiScore;
  HiScores: array[1..15] of THiScore;

implementation

{$R *.dfm}

procedure TfGameField.l4DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if not (Source is TLabel) then exit;
  //if (Source as TLabel).Caption<>'' then
	Accept:=true;
end;

procedure TfGameField.l1DragDrop(Sender, Source: TObject; X, Y: Integer);
var
	Buf: string;
begin
	Buf:=(Sender as TLabel).Caption;
  (Sender as TLabel).Caption:=(Source as TLabel).Caption;
  (Source as TLabel).Caption:=Buf;
end;

procedure TfGameField.ld1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
	Buf: string;
begin
	if Button<>mbRight then exit;
  Buf:=(Sender as TLabel).Caption;
	if l1.Caption='' then begin
  	(Sender as TLabel).Caption:=l1.Caption;
    l1.Caption:=Buf;
    exit;
  end;
	if l2.Caption='' then begin
  	(Sender as TLabel).Caption:=l2.Caption;
    l2.Caption:=Buf;
    exit;
  end;
	if l3.Caption='' then begin
  	(Sender as TLabel).Caption:=l3.Caption;
    l3.Caption:=Buf;
    exit;
  end;
	if l4.Caption='' then begin
  	(Sender as TLabel).Caption:=l4.Caption;
    l4.Caption:=Buf;
    exit;
  end;
end;

procedure TfGameField.l1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
	Buf: string;
begin
	if Button<>mbRight then exit;
  Buf:=(Sender as TLabel).Caption;
  if Buf='' then exit;
  case Buf[1] of
  	'1': begin
    		if ld1.Caption='' then begin
        	(Sender as TLabel).Caption:='';
          ld1.Caption:=Buf;	
        end;
    	end;
  	'2': begin
    		if ld2.Caption='' then begin
        	(Sender as TLabel).Caption:='';
          ld2.Caption:=Buf;
        end;
    	end;
  	'3': begin
    		if ld3.Caption='' then begin
        	(Sender as TLabel).Caption:='';
          ld3.Caption:=Buf;
        end;
    	end;
  	'4': begin
    		if ld4.Caption='' then begin
        	(Sender as TLabel).Caption:='';
          ld4.Caption:=Buf;
        end;
    	end;
  	'5': begin
    		if ld5.Caption='' then begin
        	(Sender as TLabel).Caption:='';
          ld5.Caption:=Buf;
        end;
    	end;
  	'6': begin
    		if ld6.Caption='' then begin
        	(Sender as TLabel).Caption:='';
          ld6.Caption:=Buf;
        end;
    	end;
  	'7': begin
    		if ld7.Caption='' then begin
        	(Sender as TLabel).Caption:='';
          ld7.Caption:=Buf;
        end;
    	end;
  	'8': begin
    		if ld8.Caption='' then begin
        	(Sender as TLabel).Caption:='';
          ld8.Caption:=Buf;
        end;
    	end;
  	'9': begin
    		if ld9.Caption='' then begin
        	(Sender as TLabel).Caption:='';
          ld9.Caption:=Buf;	
        end;
    	end;
  end;
end;

procedure TfGameField.bNewClick(Sender: TObject);
const
	digits: string[9]='123456789';
var
	i,n: integer;
begin
	Num:='0000';
  for i:=1 to 4 do begin
    repeat
  		n:=random(9)+1;
    until pos(digits[n],Num)=0;
    Num[i]:=digits[n];
  end;
  if mMes.Lines.Count>0 then
	  mMes.Lines.Add('----------------');
  mMes.Lines.Add(' .');
  Tries:=0;
  l1.Caption:='';
  l2.Caption:='';
  l3.Caption:='';
  l4.Caption:='';
  ld1.Caption:='1';
  ld2.Caption:='2';
  ld3.Caption:='3';
  ld4.Caption:='4';
  ld5.Caption:='5';
  ld6.Caption:='6';
  ld7.Caption:='7';
  ld8.Caption:='8';
  ld9.Caption:='9';
  lt1.Caption:='';
  lt2.Caption:='';
  lt3.Caption:='';
  lt4.Caption:='';
  lt5.Caption:='';
  lt6.Caption:='';
  lt7.Caption:='';
  lt8.Caption:='';
  lt9.Caption:='';
  lt10.Caption:='';
  lt11.Caption:='';
  sb1.Down:=false;
  sb2.Down:=false;
  sb3.Down:=false;
  sb4.Down:=false;
  {}
  if cbAutoSelect.Checked then begin
	  l1.Caption:='1';
  	l2.Caption:='2';
	  l3.Caption:='3';
  	l4.Caption:='4';
	  ld1.Caption:='';
  	ld2.Caption:='';
	  ld3.Caption:='';
  	ld4.Caption:='';
    if cbAutoStart.Checked then begin
    	bTest.Click;
    end;
  end;
  { - }
end;

procedure RefreshRecordTable;
var
	i, j: integer;
  hsr: THiScore;
  s: string;
begin
 with fGameField do begin
  {  }
  reset(hs);
  mHS.Clear;
 	for i:=1 to 15 do begin
   	read(hs,hsr);
    HiScores[i]:=hsr;
    s:='';
    if i<10 then begin
    	s:=' ';
    end;
    s:=s+inttostr(i)+'. '+HiScores[i].Name+'  ';
    for j:=1 to 12-length(HiScores[i].Name) do begin
    	s:=s+' ';
    end;
    if HiScores[i].Score<10 then begin
    	s:=s+' ';
    end;
    if HiScores[i].Score<100 then begin
    	s:=s+' ';
    end;
    s:=s+inttostr(HiScores[i].Score);
    mHS.Lines.Add(s)
  end;
  closefile(hs);
  {   - }
 end;
end;

procedure SaveRecords;
var
	i: integer;
begin
	{   }
  rewrite(hs);
  for i:=1 to 15 do begin
  	write(hs,HiScores[i]);
  end;
  closefile(hs);
	{    - }
end;

procedure TfGameField.FormCreate(Sender: TObject);
var
	i: integer;
  hsr: THiScore;
begin
	randomize;
  AssignFile(hs,hsf);
  if not FileExists(hsf) then begin
    rewrite(hs);
    hsr.Name:='<>';
    hsr.Score:=255;
  	for i:=1 to 15 do begin
    	write(hs,hsr);    	
    end;
  end;
  RefreshRecordTable;
  bNew.Click;
end;

procedure TfGameField.bTestClick(Sender: TObject);
var
	i, n, m, j: integer;
  test: string[4];
begin
	if Num='0000' then exit;
  if (l1.Caption='') or (l2.Caption='') or
  	(l3.Caption='') or (l4.Caption='') then exit;
  inc(Tries);
  n:=0;
  m:=0;
  test:=l1.Caption+l2.Caption+
  	l3.Caption+l4.Caption;
  for i:=1 to 4 do begin
  	if test[i]=Num[i] then begin
      inc(n);
      inc(m);
    end else begin
      if pos(test[i],Num)>0 then begin
      	inc(n);
      end;
    end;
  end;
  mMes.Lines.Add('['+test+']  '+inttostr(n)+' - '+
  	inttostr(m));
  if test=Num then begin
  	Num:='0000';
  	mMes.Lines.Add('! : '+inttostr(Tries));
    if Tries<HiScores[15].Score then begin
    	{for i:=14 downto 1 do begin
      	if Tries>=HiScores[i].Score then begin
        	for j:=14 downto i+1 do begin
            if j<15 then
	          	HiScores[j+1]:=HiScores[j];
          end;
          HiScores[i+1].Name:=InputBox(' !',
          	'    !  :',
            '');
          HiScores[i+1].Score:=Tries;
        end;
      end;}
      for i:=1 to 15 do begin
      	if Tries<HiScores[i].Score then begin
        	for j:=14 downto i do begin
          	HiScores[j+1]:=HiScores[j];
          end;
          HiScores[i].Name:=InputBox(' !',
          	'    !   '+
            '( 12 ):','');
          HiScores[i].Score:=Tries;
          break;
        end;
      end;
      SaveRecords;
      RefreshRecordTable;
    end;
  end;
end;

procedure TfGameField.cbAutoSelectClick(Sender: TObject);
begin
	cbAutoStart.Enabled:=cbAutoSelect.Checked;
end;

end.
